unit uDynamicalObjects;

{
  ,        .
    ,       
        
}

interface

uses Windows, Messages, KOL;

type
  {  ,       
        }
  PCustom = ^TCustom;
  TCustom = record
    Form, Memo: PControl; //    ,     
    RectangleName,
    VariableName: string;
  end;   

function FindControl(RectangleName: string): INTEGER;
function RemoveControl(RectangleName: string; ShowErrors: BOOLEAN): BOOLEAN;
function SetControl(RectangleName, NewValue: string): BOOLEAN;
function CreateControl(RectangleName, Text, VariableName: string): BOOLEAN;
procedure ClearObjList;

var
  ObjList: PList;

implementation

uses PlugInUtils;

{}

procedure OnChange( Dummy, Sender: PObj );
begin
 { if VariableName > '' then
    nbSetVar(PChar(VariableName), PChar(Int2Str(Value)));    }
end;

function OnMessage(Dummy: Pointer; var Msg: TMsg; var Rslt: Integer ): Boolean;
var R: TRect;
begin
  Result := False;
  if Msg.message = WM_NOTIFYPLUGINOBJECT then
  begin
    case Msg.lParam of
      1: ; //  
      2: ; //   
      3: ; //   
      4: begin
         //    ,   
         Windows.GetClientRect(GetParent(Msg.hwnd), R);
         SetWindowPos(Msg.hwnd, 0, 0, 0, R.Right - R.Left, R.Bottom - R.Top, SWP_SHOWWINDOW);
      end;
    end; //case   
  end; //if
end;

{   NeoBook }

function CheckVer: BOOLEAN;
var P: PCHAR;
begin
  Result := FALSE;
  if Assigned(nbInterface) then
  try
    P := nil;
    nbInterface(6, P);
      {  NeoBook - 4.0.9  ,  P   
         P = NIL, ,   }
    Result := P <> nil
  finally
    FreeStr(P);
  end;
end;

{     }

function FindControl(RectangleName: string): INTEGER;
var
  I: INTEGER;
  Control: PCustom;
begin
  Result := -1;
  I := 0;
  if Assigned(ObjList) then
    while (I < ObjList.Count) and (Result = -1) do
    begin
      Control := PCustom(ObjList.Items[I]);
      if AnsiCompareText(Control.RectangleName, RectangleName) = 0 then
        Result := I;
      Inc(I);
    end;
end;

{     }

function RemoveControl(RectangleName: string; ShowErrors: BOOLEAN): BOOLEAN;
var
  Found: INTEGER;
  Control: PCustom;
begin
  Result := FALSE;
  try
    Found := FindControl(RectangleName);

    if Found > -1 then
    begin
      Control := PCustom(ObjList.Items[Found]);
      if Control.VariableName > '' then
        nbSetVar(PChar(Control.VariableName), '');
      Control.Form.Free;
      Dispose(Control);
      ObjList.Delete(Found);
      Result := TRUE;
    end
    else if ShowErrors then
      nbSetVar('[LastError]', PChar('There is no control attached to an object named ' + RectangleName + '.'));

  finally
  {except on E: Exception do
      nbSetVar('[LastError]', PChar(E.Message));  }
  end;
end;

{    }

function SetControl(RectangleName, NewValue: string): BOOLEAN;
var
  Found: INTEGER;
  Control: PCustom;
begin
  Result := FALSE;
  try
    Found := FindControl(RectangleName);

    if Found > -1 then
    begin
      Control := PCustom(ObjList.Items[Found]);
      //    
      Control.RectangleName := NewValue;
      Result := TRUE;
    end
    else nbSetVar('[LastError]',
        PChar('There is no spin edit control attached to an object named ' + RectangleName + '.'));

  {except on E: Exception do
      nbSetVar('[LastError]', PChar(E.Message)); }
  finally
  end;
end;

{   }

function CreateControl(RectangleName, Text, VariableName: string): BOOLEAN;
var
  P: PCHAR;
  ObjHandle: HWND;
  R: TRect;
  C: PCustom;
begin
  Result := FALSE;
  try
    if CheckVer then
    begin
      {       ,   ,   }
      RemoveControl(RectangleName, FALSE);

      {     }
      try
        P := nil;
        SetStr(P, RectangleName);
        nbInterface(7, P);
        ObjHandle := HWND(Str2Int(P));
      finally
        FreeStr(P);
      end;

      if ObjHandle <> 0 then
      begin
        {   .  }

        C := New(PCustom);
        C.Form := NewForm(Applet, '');
        C.Form.Style := WS_POPUP or WS_VISIBLE;
        C.Form.Border := 0;
        C.Form.Font.FontHeight := -11;     
        C.Memo := NewEditBox( C.Form, [ eoMultiline ] ).SetAlign ( caClient );
        C.Form.Add2AutoFree(C.Memo);
        C.Form.GetWindowHandle;
        SetParent(C.Form.Handle, ObjHandle);

        C.VariableName := VariableName;
        C.RectangleName := RectangleName;
        C.Memo.Text := Text;

        {   .  }
        Windows.GetClientRect(ObjHandle, R);
        SetWindowPos(C.Form.Handle, 0, 0, 0,
          R.Right - R.Left, R.Bottom - R.Top, SWP_SHOWWINDOW);

        {     }
        ObjList.Add(C);
        C.Form.Show;
        C.Memo.Show;

        C.Form.OnMessage := TOnMessage(MakeMethod(nil, @OnMessage));
        C.Memo.OnChange := TOnEvent(MakeMethod(nil, @OnChange));

        Result := TRUE;
      end
      else nbSetVar('[LastError]', PChar('An object named ' + RectangleName + ' does not exist.'));

    end
    else nbSetVar('[LastError]', 'This function requires NeoBook 4.0.9 or higher.');

  {except on E: Exception do
      nbSetVar('[LastError]', PChar(E.Message));  }
  finally
  end;
end;

{    }

procedure ClearObjList;
var
  i: Integer;
  Control: PCustom;
begin
  for i := 0 to ObjList.Count - 1 do
  begin
    Control := PCustom(ObjList.Items[i]);
    if Assigned(Control) then
    begin
      Control.Form.Free;
      Dispose(Control);
    end;//if
  end;
end;

{  initialization / finalization }

initialization
  ObjList := NewList;
  Applet := NewApplet('');
  Applet.Hide;

finalization
  ObjList.Free;
  if Applet <> nil then Applet.Free;
  Applet := nil;
  AppletTerminated := FALSE;

end.

